=== debian/changelog ===
cppad (2020.00.00.3-1) unstable; urgency=medium

  * New upstream release
  * harden (no actual effect)
  * Bump policy
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Set upstream metadata fields: Bug-Database.
  * Update standards version to 4.5.0, no changes needed.
  * Debhelper 13
  * Augment quilt spelling patch: incase ⟼ in␠case
  * Upstream now generates library, so reorganize into lib/lib-dev/lib-doc
  * Old cppad package becomes transition package

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 27 May 2020 16:31:04 +0100
